game = {}

tile_size = 32
draw_distance = 32
light = true

local pa = math.random() * 1000

function game.initialize()
	map.new(1000, 1000, 16, 3)
	local w, h = map:getSize()
	player:initialize(math.random(w), math.random(h))
	camera:initialize()
end

function game.update(dt)
	player:update(dt)
end

function game.draw()
	camera:set()
	map.draw()
	player:draw()
	camera:unset()
	
	minimap:draw()
	
	love.graphics.setColor(255, 0, 0, 255)
	--love.graphics.print(getMouseCell().." Oh and pa: "..pa.."\nAnd fps: "..love.timer.getFPS(), 12, 12)
end

function game.keypressed(key)
	if key == "w" or key == "up" then
		player:move("up")
	elseif key == "s" or key == "down" then
		player:move("down")
	elseif key == "d" or key == "right" then
		player:move("right")
	elseif key == "a" or key == "left" then
		player:move("left")
	end
	
	if key == "tab" then light = not light end
	
	if key == " " then
		pa = math.random() * 1000
		game.initialize()
	end
end

function game.mousepressed(x, y, k)
	if k == "wu" then
		camera.zoom = camera.zoom - 0.1
	elseif k == "wd" then
		camera.zoom = camera.zoom + 0.1
	end
end











