local game_fullscreen = true

--initiallizing
local width, height, flags = love.window.getMode()
local dw, dh = love.window.getDesktopDimensions(flags.display)
if game_fullscreen then
	love.window.setMode(dw, dh, flags)
	love.window.setFullscreen(true)
else
	love.window.setMode(dw / 2, dh / 2, flags) 
end

screen = {
		width = love.graphics.getWidth(),
		height = love.graphics.getHeight()
	}

local game_name = "Cave Game"
	
--LOADING FILES
bresenham = require "bresenham"
require "color"
require "camera"
require "map"
require "player"
require "game"
require "minimap"

--img
img = {
		floor = love.graphics.newImage("assets/img/map/floor.png")
	}
	
font = {
		small = love.graphics.newFont("assets/font/font.otf", 16),
		medium = love.graphics.newFont("assets/font/font.otf", 24),
		large = love.graphics.newFont("assets/font/font.otf", 32)
	}

--GAMESTATE SHIT
state = {
		game = "game",
		menu = "menu"
	}
local game_state = state.game

function love.load()
	game.initialize()
	
	love.timer.step()
end

function love.update(dt)
	if game_state == state.game then
		game.update(dt)
	elseif game_state == state.menu then
		
	end
	love.window.setTitle(game_name.." [fps: "..love.timer.getFPS().."] [w: "..screen.width.." h: "..screen.height.."]")
end

function love.draw()
	if game_state == state.game then
		game.draw()
	elseif game_state == state.menu then
		
	end
	
	local txt = "[fps: "..love.timer.getFPS().."] [w: "..screen.width.." h: "..screen.height.."]"
	local f = love.graphics.getFont()
	love.graphics.setColor(0, 255, 0, 255)
	love.graphics.setFont(font.small)
	love.graphics.print(txt, (screen.width / 2) - (f:getWidth(txt) / 2), 12)
end

function love.keypressed(key)
	if key == "escape" then love.event.push("quit") end
	
	if game_state == state.game then
		game.keypressed(key)
	elseif game_state == state.menu then
			
	end
end

function love.mousepressed(x, y, k)
	if game_state == state.game then
		game.mousepressed(x, y, k)
	elseif game_state == state.menu then
			
	end
end

function love.resize(w, h)
	screen.width = w
	screen.height = h
	--love.window.setMode(math.floor(w), math.floor(h), {resizable=true})
end

function getDistance(x1, y1, x2, y2)
	local dx = x1-x2
	local dy = y1-y2
	return math.sqrt((dx * dx + dy * dy))
end