map = {}

local current = {
		width = 0,
		height = 0,
		map = {}
	}


function map.new(width, height, scale, par)
	
	current.width = width
	current.height = height
	
	local ox = math.random() * 2000
	local oy = math.random() * 2000
	
	for y=0, height-1 do
		current.map[y] = {}
		for x=0, width-1 do
			local tile = math.floor(love.math.noise(ox + x / scale, oy + y / scale, par) * 2)
			local durabilty = 0
			if tile == 1 then
				tile = "wall"
				durabilty = 2
			else
				local r = math.random(100)
				tile = "floor"
				if r < 2 then
					tile = "gold"
				end
			end
			current.map[y][x] = {
					x = x * tile_size,
					y = y * tile_size,
					type = tile,
					light = 255,
					seen = false,
					durabilty = durabilty
				}
		end
	end
end

function map.draw()
	for y=0, current.height-1 do
		for x=0, current.width-1 do
			if getDistance(player.x, player.y, x, y) < draw_distance then
				local tile = current.map[y][x]
				
				if light then
					--light
					local los = bresenham.los(player.x, player.y, x, y, function(x, y)
						local tile = map.getCell(x, y)
						if tile == "wall" then return false end
						
						
						if  tile == "floor" or tile == "gold"  then return true end
					end)
					
					if los then
						tile.light = (255 * 10) / (getDistance(player.x, player.y, x, y) * 18)
						if tile.light > 255 then tile.light = 255 elseif tile.light < 3 then tile.light = 0 end
						tile.seen = true
					else
						tile.light = 0
					end
				else
					tile.light = 255
				end
				if tile.light > 0 then
					if tile.type == "floor" then
						love.graphics.setColor(color.map.floor[1], color.map.floor[2], color.map.floor[3], tile.light)
						love.graphics.draw(img.floor, x * tile_size, y * tile_size)
					elseif tile.type == "wall" then
						love.graphics.setColor(color.map.wall[1], color.map.wall[2], color.map.wall[3], tile.light)
						love.graphics.rectangle("fill", x * tile_size, y * tile_size, tile_size, tile_size)
					elseif tile.type == "gold" then
						love.graphics.setColor(color.map.money[1], color.map.money[2], color.map.money[3], tile.light)
						love.graphics.rectangle("fill", x * tile_size, y * tile_size, tile_size, tile_size)
					end
				end

				--love.graphics.circle("fill", (x * tile_size) + (tile_size / 2), (y * tile_size) + (tile_size / 2), tile_size / 2, 4)
			end
		end
	end
end


function getMouseCell()
	local x, y = camera:getMouse()
	x = math.floor(x / tile_size)
	y = math.floor(y / tile_size)
	
	if x < current.width and x > 0 and y < current.height and y > 0 then
		return current.map[y][x].type
	else
		return "faggot"
	end
end

function map.getSize()
	return current.width, current.height
end

function map.getCell(x, y)
	if x < current.width and x > 0 and y < current.height and y > 0 then
		return current.map[y][x].type
	end
end

function map.getTile(x, y)
	if x < current.width and x > 0 and y < current.height and y > 0 then
		return current.map[y][x]
	else
		return false
	end
end

function map.setCell(x, y, c)
	if x < current.width and x > 0 and y < current.height and y > 0 then
		current.map[y][x].type = c 
	end
end












