minimap = {
		x = 12,
		y = screen.height - 256 - 12,
		width = 256,
		height = 256,
		scale = tile_size / 8
	}

function minimap:update(dt)

end

function minimap:draw()
	local sx = player.x - (self.width / 2) / self.scale
	local sy = player.y - (self.height / 2) / self.scale
	
	local ex = sx + (self.width / self.scale)
	local ey = sy + (self.height / self.scale)
	
	local w, h = 0, 0
	
	for y=sy, ey-1 do
		for x=sx, ex-1 do
			local cell = map.getCell(x, y)
			local tile = map.getTile(x, y)
			if not tile == false and tile.seen then
				if cell == "floor" then
					love.graphics.setColor(color.minimap.floor[1], color.minimap.floor[2], color.minimap.floor[3], 255)
				elseif cell == "wall" then
					love.graphics.setColor(color.minimap.wall[1], color.minimap.wall[2], color.minimap.wall[3], 255)
				end
				love.graphics.rectangle("fill", self.x + w, self.y + h, self.scale, self.scale)
			end
			w = w + self.scale
		end
		w = 0
		h = h + self.scale
	end
	
	love.graphics.setColor(color.player)
	love.graphics.rectangle("fill", self.x + self.width / 2, self.y + self.height / 2, self.scale, self.scale)
	
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.rectangle("line", self.x, self.y, self.width, self.height)
end