player = {
	x = 0,
	y = 0,
	gold = 0
}

function player:initialize(x, y)
	self.x = x
	self.y = y
	if map.getCell(self.x, self.y) == "wall" then
		local w, h = map:getSize()
		player:initialize(math.random(w), math.random(h))
	end
end

function player:update(dt)
	local dx  = (self.x * tile_size) - (screen.width / 2) + (tile_size / 2)
	local dy = (self.y * tile_size) - (screen.height / 2) + (tile_size / 2)
	
	if camera.x < dx then
		camera.x = camera.x + camera.speed * dt
		if camera.x > dx then
			camera.x = dx
		end
	elseif camera.x > dx then
		camera.x = camera.x - camera.speed * dt
		if camera.x < dx then
			camera.x = dx
		end
	end
	
	if camera.y < dy then
		camera.y = camera.y + camera.speed * dt
		if camera.y > dy then
			camera.y = dy
		end
	elseif camera.y > dy then
		camera.y = camera.y - camera.speed * dt
		if camera.y < dy then
			camera.y = dy
		end
	end
end

function player:draw()
	love.graphics.setColor(color.player)
	love.graphics.rectangle("fill", self.x * tile_size, self.y * tile_size, tile_size, tile_size)
end

function player:move(direction)
	local newPos = {x = self.x, y = self.y}
	if direction == "left" then
		newPos.x = newPos.x - 1
	elseif direction == "right" then
		newPos.x = newPos.x + 1
	elseif direction == "up" then
		newPos.y = newPos.y - 1
	elseif direction == "down" then
		newPos.y = newPos.y + 1
	end
	
	--collision
	local tile = map.getTile(newPos.x, newPos.y)
	if tile ~= false then
		if tile.type == "wall" then
			if tile.durabilty > 0 then
				tile.durabilty = tile.durabilty -1
				newPos.x = self.x
				newPos.y = self.y
			else
				map.setCell(newPos.x, newPos.y, "floor")
			end
		elseif tile.type == "gold" then
			map.setCell(newPos.x, newPos.y, "floor")
		end
	else
		newPos.x = self.x
		newPos.y = self.y
	end
	
	
	self.x = newPos.x
	self.y = newPos.y
end





